unit Unit1;

interface

uses
  Windows, Messages, SysUtils, Variants, Classes, Graphics, Controls, Forms,
  Dialogs, StdCtrls;

type
  SetOfByte = set of Byte;

  TForm1 = class(TForm)
    Edit1: TEdit;
    Edit2: TEdit;
    Label1: TLabel;
    GroupBox1: TGroupBox;
    Label2: TLabel;
    GroupBox2: TGroupBox;
    Memo1: TMemo;
    Button1: TButton;
    Button2: TButton;
    Label3: TLabel;
    procedure Button2Click(Sender: TObject);
    procedure Button1Click(Sender: TObject);
  private
    { Private declarations }
  public
    { Public declarations }
  end;

function Zhodne(const a,b:string):SetOfByte; pascal

var
  Form1: TForm1;

implementation

{$R *.dfm}

function Zhodne(const a,b:string):SetOfByte; pascal;
asm
  push ebx
  push ebp
  push edi
  push esi

  mov  esi, a
  mov  ebx, b
  mov  edi, @result // vynulovanie vysledku
  mov  ecx, 8
@1:
  mov  dword ptr [edi],0
  add  edi, 4
  loop @1
  // vysledok mame vynulovany
  cmp  esi, 0  // je nejake pole v a?
  je   @bin
  cmp  ebx, 0  // je nejake pole v b?
  je   @bin     // ak nejake pole neexistovalo, tak skoci na @bin - Bad INput
  mov  al, [esi-4]  // v al mam dlzku retazca a
  mov  ah, [ebx-4]  // a v ah mam dlzku retazca b
  cmp  al, ah
  je   @rovne
  ja   @lviac
  jb   @hviac
  mov  ecx, 255
  jmp  @rob
@rovne:
  cmp  al, 255
  jnb  @rob
  mov  ecx, 0
  mov  cl, al
  jmp  @rob
@lviac:
  mov  ecx, 0
  mov  cl, ah
  jmp  @rob
@hviac:
  mov  ecx, 0
  mov  cl, al
  jmp  @rob
  // v ecx mam ulozenu minimalnu dlzku pascalovskeho retazca (budem to opakovat dovtedy dokym mam najkr. retazec)

@rob:
  mov edx, 1 // edx je pocitadlo
@lp:
  mov  al, [esi+edx*1-1]
  mov  ah, [ebx+edx*1-1]
  cmp  al, ah
  jne  @nic

  push edi
  push ecx
  push eax
  mov  eax,0
  mov  edi, @result

  mov cl, dl
  and cl, 7
  mov ch, 1
  shl ch, cl
  mov al, dl
  shr al, 3
  or [edi+eax], ch

  pop  eax
  pop  ecx
  pop  edi
  
@nic:
  inc  edx
  loop @lp
  jmp  @totend

@bin:
  mov  edi, @result
  mov  [edi], 1

@totend:
  pop  esi
  pop  edi
  pop  ebp
  pop  ebx
end;

procedure TForm1.Button2Click(Sender: TObject);
begin
Halt;
end;

procedure TForm1.Button1Click(Sender: TObject);
var x:set of Byte;
    i: integer;
    s: string;
begin
x:=[]; s:='';
x:=Zhodne(Form1.Edit1.Text, Form1.Edit2.Text);
for i:=1 to 255 do begin
  if i in x then s:=s+IntToStr(i)+', ';
end;
Memo1.Lines.Add(s);
//if 0 in x then Memo1.Lines.Add('Bad Input');
end;

end.
